%define buildsmp 1
Name: kernel
Summary: The Security Enhanced Linux Kernel
Version: 2.4.21 
Release: selinux2
License: GPL
Group: System Environment/Kernel
Vendor: The Linux Community
Source: kernel-2.4.21-selinux2.tgz
BuildRoot: /var/tmp/%{name}-%{PACKAGE_VERSION}-root
%define __spec_install_post /usr/lib/rpm/brp-compress || :
%define debug_package %{nil}
%define kernel_prereq checkpolicy, fileutils, initscripts, libselinux, mkinitrd, modutils,policy, policycoreutils, policy-sources
%define KVERREL %{PACKAGE_VERSION}-%{PACKAGE_RELEASE}
Prereq: %{kernel_prereq}


%description
The Security Enhanced Linux Kernel, the operating system core itself

%package smp
Summary: The Security Enhanced Linux kernel compiled for SMP machines.
Group: System Environment/Kernel
Provides: kernel = %{version}
Prereq: %{kernel_prereq}

%description smp
This package includes a SMP version of the SELinux kernel. It is
required only on machines with two or more CPUs.

%prep
%setup -q

%build
#make oldconfig dep clean bzImage modules
#make dep clean bzImage modules


BuildKernel() {
	if [ -n "$1" ] ; then
		Config=%{version}-%{release}-%{_target_cpu}-$1
		KernelVer=%{version}-%{release}-$1
		echo BUILDING A KERNEL FOR $1 %{_target_cpu}...
		perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%{release}-$1/" Makefile
	else
		Config=%{version}-%{release}-%{_target_cpu}
		KernelVer=%{version}-%{release}
		echo BUILDING THE NORMAL KERNEL for %{_target_cpu}...
		perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%{release}/" Makefile
	fi

        make mrproper
        # We do make oldconfig twice; otherwise, make oldconfig tends to get stuff
        # wrong in the light of cyclic dependencies
	cp configs/kernel-$Config.config .config
	make oldconfig
	make oldconfig
        make scripts/mkdep
	make clean
	make dep 
	make  include/linux/version.h 
        make clean bzImage modules

	mkdir -p $RPM_BUILD_ROOT/boot $RPM_BUILD_ROOT/lib $RPM_BUILD_ROOT/lib/modules
	INSTALL_MOD_PATH=$RPM_BUILD_ROOT make modules_install 
	cp arch/%{_target_cpu}/boot/bzImage $RPM_BUILD_ROOT/boot/vmlinuz-$KernelVer
	cp System.map $RPM_BUILD_ROOT/boot/System.map-$KernelVer
	cp .config $RPM_BUILD_ROOT/boot/config-$KernelVer
}


BuildKernel
BuildKernel enforcing
BuildKernel noselinux

%if %{buildsmp}
BuildKernel smp
BuildKernel enforcing-smp
BuildKernel noselinux-smp
%endif

%install
#mkdir -p $RPM_BUILD_ROOT/boot $RPM_BUILD_ROOT/lib $RPM_BUILD_ROOT/lib/modules
#INSTALL_MOD_PATH=$RPM_BUILD_ROOT make modules_install
#cp arch/i386/boot/bzImage $RPM_BUILD_ROOT/boot/vmlinuz-2.4.21-selinux2
#cp System.map $RPM_BUILD_ROOT/boot/System.map-2.4.21-selinux2
#cp .config $RPM_BUILD_ROOT/boot/config-2.4.21-selinux2

mkdir -p $RPM_BUILD_ROOT/usr/src/redhat/BUILD
mkdir -p $RPM_BUILD_ROOT/usr/src/redhat/SOURCES
mkdir -p $RPM_BUILD_ROOT/usr/src/redhat/SRPMS
mkdir -p $RPM_BUILD_ROOT/usr/src/redhat/SPECS
mkdir -p $RPM_BUILD_ROOT/usr/src/redhat/RPMS/athlon
mkdir -p $RPM_BUILD_ROOT/usr/src/redhat/RPMS/i386
mkdir -p $RPM_BUILD_ROOT/usr/src/redhat/RPMS/i486
mkdir -p $RPM_BUILD_ROOT/usr/src/redhat/RPMS/i586
mkdir -p $RPM_BUILD_ROOT/usr/src/redhat/RPMS/i686
mkdir -p $RPM_BUILD_ROOT/usr/src/redhat/RPMS/noarch

%clean
rm -rf $RPM_BUILD_ROOT

%post
InstallModules(){
	if [ -n "$1" ] ; then
		KernelVer=%{version}-%{release}-$1
	else
		KernelVer=%{version}-%{release}
	fi
	ln -sf module-info-$KernelVer module-info
	[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
	[ -x /sbin/mkkerneldoth ] && /sbin/mkkerneldoth
	if [ -x /sbin/new-kernel-pkg ] ; then
        	/sbin/new-kernel-pkg --mkinitrd --depmod --install $KernelVer
	fi
}

InstallModules noselinux
InstallModules enforcing
InstallModules

%post smp
InstallModules(){
	if [ -n "$1" ] ; then
		KernelVer=%{version}-%{release}-$1
	else
		KernelVer=%{version}-%{release}
	fi
	ln -sf module-info-$KernelVer module-info
	[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
	[ -x /sbin/mkkerneldoth ] && /sbin/mkkerneldoth
	if [ -x /sbin/new-kernel-pkg ] ; then
        	/sbin/new-kernel-pkg --mkinitrd --depmod --install $KernelVer
	fi
}

InstallModules noselinux-smp
InstallModules enforcing-smp
InstallModules smp

%preun
/sbin/modprobe loop 2> /dev/null > /dev/null  || :
#rm -f /lib/modules/%{KVERREL}/modules.*
if [ -x /sbin/new-kernel-pkg ] ; then
 /sbin/new-kernel-pkg --rminitrd --rmmoddep --remove 2.4.21-selinux2 
fi

%files
%defattr (-, root, root)
%dir /lib/modules
/lib/modules/%{KVERREL}
/boot/vmlinu?-%{KVERREL}
/boot/System.map-%{KVERREL}
/boot/config-%{KVERREL}
/lib/modules/%{KVERREL}-enforcing
/boot/vmlinu?-%{KVERREL}-enforcing
/boot/System.map-%{KVERREL}-enforcing
/boot/config-%{KVERREL}-enforcing
/lib/modules/%{KVERREL}-noselinux
/boot/vmlinu?-%{KVERREL}-noselinux
/boot/System.map-%{KVERREL}-noselinux
/boot/config-%{KVERREL}-noselinux
%dir /usr/src/redhat/*


%if %{buildsmp}
%files smp
%defattr (-, root, root)
%dir /lib/modules
/lib/modules/%{KVERREL}-smp
/boot/vmlinu?-%{KVERREL}-smp
/boot/System.map-%{KVERREL}-smp
/boot/config-%{KVERREL}-smp
/lib/modules/%{KVERREL}-enforcing-smp
/boot/vmlinu?-%{KVERREL}-enforcing-smp
/boot/System.map-%{KVERREL}-enforcing-smp
/boot/config-%{KVERREL}-enforcing-smp
/lib/modules/%{KVERREL}-noselinux-smp
/boot/vmlinu?-%{KVERREL}-noselinux-smp
/boot/System.map-%{KVERREL}-noselinux-smp
/boot/config-%{KVERREL}-noselinux-smp
%endif

%changelog
* Tue Nov 10 2003 Yuichi Nakamura <ynakam@sourceforge.jp>
-add support for enforcing kernel and without SELinux kernel
-add smp package
* Wed Oct 8 2003 Youichi Hirose  <yhirose@sourceforge.jp>
- Original
